-module(gmaps).
-include_lib("xmerl/include/xmerl.hrl").

compute_eta({Lat1, Lng1}, {Lat2, Lng2}) ->
    %% Make the request
    Url = io_lib:format("http://maps.googleapis.com/maps/api/directions/xml?origin=~f,~f&destination=~f,~f&sensor=false", [Lat1, Lng1, Lat2, Lng2]),
    {ok, {_Status, _Headers, Body}} = httpc:request(Url),
    
    %% Parse the XML result
    {Doc, _} = xmerl_scan:string(Body),

    [#xmlText{value = Text}] = xmerl_xpath:string("/DirectionsResponse/route[1]/leg/duration/value/text()", Doc),

    list_to_integer(Text).


compute_steps({Lat1, Lng1}, {Lat2, Lng2}) ->
    %% Make the request
    Url = io_lib:format("http://maps.googleapis.com/maps/api/directions/xml?origin=~f,~f&destination=~f,~f&sensor=false", [Lat1, Lng1, Lat2, Lng2]),
    {ok, {_Status, _Headers, Body}} = httpc:request(Url),

    %% Parse the XML result
    {Doc, _} = xmerl_scan:string(Body),
    Lats = [list_to_float(Lat) ||
               #xmlText{value = Lat} <- xmerl_xpath:string("/DirectionsResponse/route[1]/leg/step/end_location/lat/text()", Doc) ],
    Lngs = [list_to_float(Lng) ||
               #xmlText{value = Lng} <- xmerl_xpath:string("/DirectionsResponse/route[1]/leg/step/end_location/lng/text()", Doc) ],
    Durs = [list_to_integer(Dur) ||
               #xmlText{value = Dur} <- xmerl_xpath:string("/DirectionsResponse/route[1]/leg/step/duration/value/text()", Doc) ],

    Positions = lists:zip(Lats,Lngs),
    Steps = lists:zip(Positions, Durs),
    Steps.


compute_pickup(Value) ->
    round(Value * 1).  % 1 secs / 1kg



  
